
;*******************************************************************************************
;                                                                                          *
;    Filename: PLL MB1501.asm                            	  	                           *
;    Date: 26 Agosto 2006                                                                  *
;    File Version: 1.0                                                                     *
;                                                                                          *
;    Author: Mauro Olivero Pistoletto                                                      *
;    Nominativo: IK1IMG                                                                    *
;                                                                                          * 
;                                                                                          *
;*******************************************************************************************
;                                                                                          *
;    Notes:per PLL MB 1501, 1502 con EEPROM,DIP,UP,DOWN,MEM,AGGANCIO                       *
;                                                                                          *
;   CONTRAVES CIFRA "0" PIN TUTTI livello logico "1" ovvero DIP aperti                     *
;                                                                                          *
;   TUTTI I NUMERI SONO IN ESADECIMALE                                                     *
;*******************************************************************************************


	list      p=16F84A            ; list directive to define processor
	#include <p16F84a.inc>        ; processor specific variable definitions


	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_OFF & _XT_OSC

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The lables following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.


	
;===========================================================================================
;  INIZIALIZZAZIONE EEPROM
;===========================================================================================


			ORG		0X2100				;indirizzamento zona EEPROM

			DATA	0X00				;RX 0 MSB N						--------------
			DATA	0XE2				;RX 0 LSB N						FREQ.145.000
			DATA	0X24				;RX 0 A							--------------

			DATA	0X00				;RX 1 MSB N						--------------
			DATA	0XE2			    ;RX 1 LSB N						FREQ.145.000
			DATA	0X24				;RX 1 A                      	--------------

			DATA	0X00				;RX 2 MSB N    					--------------
			DATA	0XE2				;RX 2 LSB N						FREQ.145.000
			DATA	0X24				;RX 2 A							--------------

			DATA	0X00				;RX 3 MSB N						--------------
			DATA	0XE2				;RX 3 LSB N						FREQ.145.000
			DATA	0X24				;RX 3 A							--------------

			DATA	0X00				;RX 4 MSB N						--------------
			DATA	0XE2				;RX 4 LSB N						FREQ.145.000
			DATA	0X24				;RX 4 A							--------------

			DATA	0X00				;RX 5 MSB N						--------------
			DATA	0XE2				;RX 5 LSB N						FREQ.145.000
			DATA	0X24				;RX 5 A							--------------

			DATA	0X00				;RX 6 MSB N						--------------
			DATA	0XE2				;RX 6 LSB N						FREQ.145.000
			DATA	0X24				;RX 6 A							--------------

			DATA	0X00				;RX 7 MSB N						--------------
			DATA	0XE2				;RX 7 LSB N						FREQ.145.000
			DATA	0X24				;RX 7 A							--------------

			DATA	0X00				;TX 0 MSB N    -   RX 8 MSB N	--------------
			DATA	0XE2				;TX 0 LSB N    -   RX 8 LSB N	FREQ.145.000
			DATA	0X24				;TX 0 A        -   RX 8 A		--------------

			DATA	0X00				;TX 1 MSB N    -   RX 9 MSB N	--------------
			DATA	0XE2				;TX 1 LSB N    -   RX 9 LSB N	FREQ.145.000
			DATA	0X24				;TX 1 A        -   RX 9 A		--------------

			DATA	0X00				;TX 2 MSB N    -   RX 10 MSB N	--------------
			DATA	0XE2				;TX 2 LSB N    -   RX 10 LSB N	FREQ.145.000
			DATA	0X24				;TX 2 A        -   RX 10 A		--------------

			DATA	0X00				;TX 3 MSB N    -   RX 11 MSB N	--------------
			DATA	0XE2				;TX 3 LSB N    -   RX 11 LSB N	FREQ.145.000
			DATA	0X24				;TX 3 A        -   RX 11 A		--------------

			DATA	0X00				;TX 4 MSB N    -   RX 12 MSB N	--------------
			DATA	0XE2				;TX 4 LSB N    -   RX 12 LSB N	FREQ.145.000
			DATA	0X24				;TX 4 A        -   RX 12 A		--------------

			DATA	0X00				;TX 5 MSB N    -   RX 13 MSB N  --------------
			DATA	0XE2				;TX 5 LSB N    -   RX 13 LSB N	FREQ.145.000
			DATA	0X24				;TX 5 A        -   RX 13 A		--------------

			DATA	0X00				;TX 6 MSB N    -   RX 14 MSB N	--------------
			DATA	0XE2				;TX 6 LSB N    -   RX 14 LSB N	FREQ.145.000
			DATA	0X24				;TX 6 A        -   RX 14 A		--------------

			DATA	0X00				;TX 7 MSB N    -   RX 15 MSB N	--------------
			DATA	0XE2				;TX 7 LSB N    -   RX 15 LSB N	FREQ.145.000
			DATA	0X24				;TX 7 A        -   RX 15 A		--------------

			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)
			DATA	0XFF				;NU (non utilizzata)

			DATA	0X00				;bit BIT_LIV per LED aggancio: (00)norm,(01)inv
			DATA	0X01				;bit SW: (00) P=128, (01) P=64 - Prescaler "P"
			DATA	0X01				;bit MSB di R					
			DATA	0X90				;bit LSB di R

;---- Promemoria riassunto settaggi --------------------------------------------------------

			;settaggio BIT_LIV			(00) NORMALE
			;settaggio BIT SW			(01) SW=1 ovvero Prescaler P=64
			;settaggio R			  	(01 90) STEP 10KHz clock PLL 4 MHz
										

;===========================================================================================
;  PROGRAMMA
;===========================================================================================


;===========================================================================================
;  REGISTRI VARI									
;===========================================================================================


CONFIG_INIZ	ORG		00					;Inizio allocazione programma 

LE			EQU		01					;PORTB pin PB1-Latch PLL
DATO		EQU		02					;PORTB pin PB2-Dato PLL
CK			EQU		03					;PORTB pin PB3-Clock PLL
DIP			EQU		0C					;reg.num.dip filtrato dalle uscite
DIP_OLD		EQU		0D					;reg.valore DIP precedente
DIP_TEST	EQU		0E					;reg.per trovare il val. di DIP per punt.EEPROM
N_MSB		EQU		0F					;reg.parte alta N
N_LSB		EQU		10					;reg.parte bassa N
A			EQU		11					;reg.A 
A_BYTE		EQU		12					;reg.per il trattamento di A per BYTE_3
SW			EQU		13					;reg.bit W selezione prescaler 64(1)/128(0)
R_MSB		EQU		14					;reg.parte alta R
R_LSB		EQU		15					;reg.parte bassa R
BYTE 		EQU		16					;reg.con byte da ruotare
BYTE_1		EQU		17					;reg.porzione di serial data al PLL
BYTE_2		EQU		18					;reg.porzione di serial data al PLL
BYTE_3		EQU		19					;reg.porzione di serial data al PLL
BYTE_4		EQU		1A					;reg.porzione di serial data al PLL
BYTE_5		EQU		1B					;reg.porzione di serial data al PLL
LOOP_BYTE  	EQU		1C					;reg.conteggia l'invio dei 5 BYTE al PLL
LOOP_BIT  	EQU		1D					;reg.conteggia l'invio degli 8 BIT al PLL
LOOP_LATCH	EQU		1E					;reg.per determinare quando eff.il load del PLL
PUNTA		EQU		1F					;reg.per puntatore tab. dei Byte da inviare al PLL
CELLA		EQU		20					;reg.indirizzo cella EEPROM
COUNT1		EQU		21					;reg.1 timer LED
COUNT2		EQU		22					;reg.2 timer LED
COUNT3		EQU		23					;reg.campionamenti per decisione aggancio
COUNT4		EQU		24					;reg.ripetizione campionamenti per decisione agg.
BIT_LIV		EQU		25					;reg.inversione/normale LED aggancio
FLAG_AGG	EQU		26					;reg.Flag PLL agganciato/sganciato
FLAG_OV		EQU		27					;reg.Falg fondo scala UP-DOWN (0,0,0,0,0,0,UP,DOWN)

;===========================================================================================
; DEFINE
;===========================================================================================

#DEFINE		BANK0	BCF STATUS,RP0
#DEFINE		BANK1	BSF	STATUS,RP0

;===========================================================================================
;  CONFIGURAZIONE INIZIALE
;===========================================================================================

CONFIG_INIZ	CLRF	FLAG_OV				;azzera bit Falg di fondo scala UP-DOWN
			CLRF	PORTA				;azzera uscite PORTA
			CLRF	PORTB				;azzera uscite PORTB
					BANK1				;passa al banco 1
			MOVLW	1C					;mette 00011100 in W
			TRIS	PORTA		 		;PORTA ingressi A4-A3-A2,out A1-A0
			MOVLW	00F1				;mette 11110001 in W
			TRIS	PORTB		 		;PORTB uscite B3-B2-B1 le altre ing.
					BANK0				;passa al banco 0
			CALL	PAR_AGG				;carica parametri per LED aggancio PLL
			MOVLW	0FF					;mette FF in W
			MOVWF	DIP_OLD				;carica in DIP_OLD FF per consen=
										;tire partenza comp. primo ciclo
					BANK1				;passa in banco 1
			BCF		OPTION_REG,NOT_RBPU	;mette a 0 il bit 7 per pullup ing.PB
					BANK0				;ritorna in banco 0
			MOVLW	18					;mette 00011000b in W
			MOVWF	STATUS				;resetta i bit Z,DC,C

;---- Legge in EEPROM: BIT_LIV,SW ed R contenuti agli indirizzi 3C,3D,3E,3F ----------------

L_EE_SW_R	MOVLW	3C					;mette indirizzo 3C in W per EEPROM 
			CALL	READ_EE				;va a leggere il contenuto della cella 3C
			MOVWF	BIT_LIV				;lo carica in BIT_LIV per LED agg.norm (00)/inv.(01)
			MOVLW	3D					;carica indirizzo 3D in W per EEPROM 
			CALL	READ_EE				;va a leggere il contenuto della cella 3D
			MOVWF	SW			  		;lo carica in SW per selez. prescaler 128(0)/64(1)
			MOVLW	3E					;carica indirizzo 3E in W per EEPROM 
			CALL	READ_EE				;va a leggere il contenuto della cella 3E
			MOVWF	R_MSB				;carica la parte pi significativa in R_MSB
			MOVLW	3F					;mette indirizzo 3F in W per EEPROM 
			CALL	READ_EE				;va a leggere il contenuto della cella 3F
			MOVWF	R_LSB				;carica la parte meno significativa in R_LSB

;---- Prepara 2 byte nel formato "serial data reference divider" del PLL -------------------

;---- SW-S14,S13,S12,S11,S10,S9,S8,S7,S6,S5,S4,S3,S2,S1-CONTROL(1)--------------------------
;    [SW][---------------------R----------------------] [C]

;---- [SW-S14-S13-S12-S11-S10-S9-S8][S7-S6-S5-S4-S3-S2-S1-C]--------------------------------
;     [---------- BYTE 4 ----------][------- BYTE 5 -------]

			BSF		STATUS,C			;mette a 1 il bit di CARRY
			RLF		R_LSB,0		 		;ruota R_LSB a sinistra e mette in W
			MOVWF	BYTE_5				;carica il nuovo valore in BYTE 5 del s.data
			RLF		R_MSB,1		 		;ruota R_MSB a sinistra
			BTFSC	SW,0				;testa bit 0 di SW se a 0 salta
			BSF		R_MSB,7				;mette a 1 SW in BYTE 4 del serial data ref.div.
			MOVF	R_MSB,0				;carica R_MSB in W
  			MOVWF	BYTE_4				;carica il nuovo valore in BYTE_4 del s.data

;===========================================================================================
;  ROUTINE DI LETTURA COMANDI - ROUTINE PRINCIPALE                                                         
;===========================================================================================

;---- Routine per lettura DIP --------------------------------------------------------------

MAIN		MOVF	PORTB,0				;legge PORTB e la mette in W
			MOVWF	DIP					;carica il valore in DIP
			SWAPF	DIP,1				;scambia tra loro i 4 bit consecutivi di DIP 
			COMF	DIP,0				;complemento dei bit di DIP poi in W
			ANDLW	0F					;filtra le uscite PB1-2-3 e ing PB
			MOVWF	DIP					;carica il valore effettivo in DIP
			SUBWF	DIP_OLD,0			;sottrae DIP_OLD a DIP
			BTFSS	STATUS,Z			;testa Z,se 1 salta (ha dato zero)
			GOTO	READ_DIP			;Z=0 va a READ_DIP

;---- Routine per pulsanti UP,DWN,MEM ------------------------------------------------------

			BTFSS	PORTA,2				;Z=1:testa bit A2 PORTA, se a 1 salta
			GOTO	VERIF_UP			; premuto puls.UP, vai a routine VERIF_UP
			BTFSS	PORTA,3				;testa bit A3 PORTA, se a 1 salta
			GOTO	VERIF_DOWN			; premuto puls.DOWN, va a routine VERIF_DOWN
			BTFSS	PORTA,4				;testa bit A4 PORTA, se a 1 salta
			GOTO	WRITE				; premuto puls.MEM, va a routine WRITE
VER_AGG		CALL 	AGGANCIO			;nulla  variato verifica aggancio
			GOTO	MAIN				;va al programma principale
;___________________________________________________________________________________________
;___________________________________________________________________________________________


;=== ROUTINE NUOVO VALORE MINIDIP PER TRASFERIRE LA FREQUENZA DALL'EEPROM AL PLL =========== 


;---- Cerca correlazione tra numero impostato su DIP e la prima delle tre celle EEPROM -

READ_DIP	CLRF	FLAG_OV				;azzera bit Falg di fondo scala UP-DOWN per new DIP
			BCF		PORTA,1				;disattiva il LED conferme se ON per fondo scala
			MOVF	DIP,0				;mette il nuovo valore di DIP in W
			MOVWF	DIP_OLD				;lo carica anche in DIP_OLD
			MOVLW	0F					;mette 0F in W
			MOVWF	DIP_TEST			;carica 0F in DIP_TEST 
LOOP_DIP	MOVF	DIP,0				;mette il valore di DIP in W
			SUBWF	DIP_TEST,0			;sottrae il valore di DIP a W
			BTFSC	STATUS,Z			;testa Z,se 0 salta (non ha dato zero)
			GOTO	SEL_CELL			;se Z=0 va a SEL_CELL
			DECF	DIP_TEST,1			;se Z=1 decrementa DIP_TEST
			GOTO	LOOP_DIP			;ripete il ciclo con il nuovo valore di DIP_TEST
SEL_CELL	MOVF	DIP,0				;mette il valore di DIP in W
			CALL	TABLE_CELL			;va a TABLE_CELL per valore indirizzo prima cella
			MOVWF 	CELLA				;carica il valore primo indirizzo in CELLA
													
;---- legge in EEPROM i parametri N ed A nelle 3 celle consecutive definite da CELLA -------

			MOVF	CELLA,0				;punta prima cella del trio
			CALL	READ_EE				;va alla routine per leggere EEPROM
			MOVWF	N_MSB				;carica la prima cella in N_MSB
			MOVF	CELLA,0				;punta seconda cella del trio
			ADDLW	01					;incrementa di 1 CELLA
			CALL	READ_EE				;va alla routine per leggere EEPROM
			MOVWF	N_LSB				;carica la terza cella in N_LSB
			MOVF	CELLA,0				;punta terza cella del trio
			ADDLW	2					;incrementa di 2 CELLA
			CALL	READ_EE				;va alla routine per leggere EEPROM
			MOVWF	A					;carica la terza cella in A

;___________________________________________________________________________________________


;=== ROUTINE PER INVIO DI UNA FREQUENZA AL PLL =============================================

			
;---- Prepara i 3 byte nel formato "programmable counter e swallow counter divide 
; ratio" del PLL----------------------------------------------------------------------------

;----  S18-S17-S16-S15-S14-S13-S12-S11-S10-S9-S8-S7-S6-S5-S4-S3-S2-S1-CONTROL(0) -----------		
;     [-------------------N--------------------] [--------A---------] [C]


;---- [0-0-0-0-0-S18-S17-S16][S15-S14-S13-S12-S11-S10-S9-S8][S7-S6-S5-S4-S3-S2-S1-C] -------
;     [------ BYTE 1 -------][---------- BYTE 2 -----------][------- BYTE 3 -------]


ROUT_PLL	MOVF	A,0					;mette A in W
			MOVWF	A_BYTE				;copia A in A_BYTE
			BCF		STATUS,C			;azzera il bit di carry
			RLF		A_BYTE,0		 	;ruota A_BYTE a sinistra
			MOVWF	BYTE_3				;carica il nuovo valore in BYTE 3 del s.data
			MOVF	N_LSB,0				;mette in W il contenuto di N_LSB
			MOVWF	BYTE_2				;trasferisce N_LSB in BYTE_2 del serial data
			MOVF	N_MSB,0				;mette in W il contenuto di N_MSB
			MOVWF	BYTE_1				;trasferisce N_MSB in BYTE_1 del serial data
					
;---- Inizializza i contatori --------------------------------------------------------------

INIZ_COUNT	MOVLW	03					;mette 3 in W
			MOVWF	LOOP_LATCH	 		;carica il cont.del latch con "3" per il primo ciclo
			MOVLW	05					;mette 5 in W
			MOVWF	LOOP_BYTE			;carica LOOP_BYTE che deve conteggiare i 5 BYTE PLL
			MOVLW	0FF					;mette FF in W
			MOVWF	PUNTA				;carica FF in PUNTA per il puntamento tabella

;---- Invia i 5 BYTE al PLL (Frequenza + Riferimento)---------------------------------------

NEW_BYTE	MOVLW	08					;mette 8 in W
			MOVWF	LOOP_BIT			;ricarica il contatore degli 8 bit seriali
			INCF	PUNTA,1				;incrementa PUNTA e lo mette PUNTA
			INCF	PUNTA,1				;incrementa PUNTA e lo mette PUNTA
			MOVF	PUNTA,0				;mette PUNTA in W
			CALL	TABLE_BYTE			;mette in W nuovo BYTE in formato PLL da tabella		
			BCF		STATUS,C			;azzera il bit di carry
			MOVWF	BYTE				;carica W in BYTE

;---- Routine per inviare il BYTE un bit alla volta al DATA del PLL ------------------------
		
RUOTA		RLF		BYTE,1				;ruota BYTE a sinistra
			BTFSS	STATUS,C			;testa carry
			GOTO	DATO_BASSO			;C=0 Dato a "0":va a DATO_BASSO
DATO_ALTO	BSF		PORTB,DATO			;C=1 Dato a "1":prosegue come DATO_ALTO
			BSF		PORTB,CK			;CK a 1
			BCF		PORTB,CK			;CK a 0
 			BCF		PORTB,DATO			;dato a 0
			GOTO	FINE_STEP			;va a FINE_STEP per ferificare rotazione terminata
DATO_BASSO	BSF		PORTB,CK			;CK a 1
 			BCF		PORTB,CK			;CK a 0
FINE_STEP	DECFSZ	LOOP_BIT,1  		;decrementa LOOP_BIT
			GOTO 	RUOTA	 			;se  a 1 va a ruota, altrimenti prosegue 
LATCH_PLL	DECFSZ	LOOP_LATCH,1  		;decrementa LOOP_LATCH
			GOTO 	COUNT_BYTE	 		;se  a 1 va a COUNT_BYTE,altrimenti attiva LATCH
			BSF		PORTB,LE			;bit LE a 1
			BCF		PORTB,LE			;bit LE a 0
			MOVLW	02					;mette 2 in W
			MOVWF	LOOP_LATCH			;ricarica contatore del LATCH con 2 per il sec.ciclo
COUNT_BYTE	DECFSZ	LOOP_BYTE,1  		;decrementa LOOP_BYTE
			GOTO 	NEW_BYTE			;se  a 1 va a NEW_BYTE
			GOTO 	MAIN				;se  a 0 va a MAIN - FINE caricamento nel PLL
;___________________________________________________________________________________________

;=== ROUTINE MEMORIZZAZIONE ================================================================

;---- ROUTINE PER SCRIVERE UN CELLA SPECIFICATA IN CELLA -----------------------------------

WRITE		CALL 	LED					;attiva il LED conferme
			MOVF	CELLA,0				;punta prima cella del trio
			MOVWF	EEADR				;carica da W indirizzo prima cella
			MOVF	N_MSB,0				;mette N_MSB in W
			MOVWF	EEDATA				;carica N_MSB in EEDATA
			CALL	WRITE_EE			;va alla routine che scrive il dato nella cella
			MOVF	CELLA,0				;punta seconda cella del trio
			ADDLW	01					;incrementa di 1 cella in W	
			MOVWF	EEADR				;carica da W indirizzo seconda cella
			MOVF	N_LSB,0				;mette L_MSB in W
			MOVWF	EEDATA				;carica L_MSB in EEDATA
			CALL	WRITE_EE			;va alla routine che scrive il dato nella cella
			MOVF	CELLA,0				;punta seconda cella del trio
			ADDLW	02					;incrementa di 2 cella in W	
			MOVWF	EEADR				;carica da W indirizzo seconda cella
			MOVF	A,0					;mette A in W
			MOVWF	EEDATA				;carica A in EEDATA
			CALL	WRITE_EE			;va alla routine che scrive il dato nella cella
			CALL 	LED					;FINE, va a confermare con 2lampeggio LED
			GOTO	MAIN				;va alla routine principale

;=== ROUTINE PER LEGGERE UN CELLA SPECIFICATA IN W =========================================

READ_EE		MOVWF	EEADR				;pone in EEADR indirizzo cella
					BANK1				;passa in banco 1
			BSF		EECON1,0			;esegue lettura
					BANK0				;ritorna in banco 0
			MOVF	EEDATA,0			;mette in W il contenuto letto di EEDATA
			RETURN						;ritorna alla chiamata

;=== ROUTINE PER SCRIVERE UN CELLA =========================================================

WRITE_EE	BANK1						;passa nel banco 1
			BSF		EECON1,WREN			;abilita la scrittura
			MOVLW	0x55				;mette 55h in W
			MOVWF	EECON2				;trasferisce 55h in EECON2
			MOVLW	0xAA				;mette AAh in W
			MOVWF	EECON2				;trasferisce AAh in EECON2
			BSF		EECON1,WR			;scrive
WAIT_WR		BTFSS	EECON1,EEIF			;testa fine scrittura,se uno salta
 			GOTO    WAIT_WR				; zero, scrittura non terminata va a WAIT_WR
			BCF		EECON1,EEIF			;resetta bit EEIF di conferma fine scrittura
			BCF		EECON1,WREN			;disabilita la scrittura 
			BANK0						;ritorna in banco 0
			RETURN						;ritorna alla chiamata

;___________________________________________________________________________________________

;===========================================================================================
;  TABELLE 
;===========================================================================================

;---- tabella corrispondenza tra DIP e celle EEPROM ----------------------------------------

TABLE_CELL	ADDWF	PCL,1				;addiziona W,cio DIP,a PCL per puntare
			RETLW	00					;carica DIP 0 RX vettore gruppo00 EEPROM
			RETLW	03					;carica DIP 1 RX vettore gruppo01 EEPROM
			RETLW	06					;carica DIP 2 RX vettore gruppo02 EEPROM
			RETLW	09					;carica DIP 3 RX vettore gruppo03 EEPROM
			RETLW	0C					;carica DIP 4 RX vettore gruppo04 EEPROM
			RETLW	0F					;carica DIP 5 RX vettore gruppo05 EEPROM
			RETLW	12					;carica DIP 6 RX vettore gruppo06 EEPROM
			RETLW	15					;carica DIP 7 RX vettore gruppo07 EEPROM
			RETLW	18					;carica DIP 0 TX vettore gruppo08 EEPROM
			RETLW	1B					;carica DIP 1 TX vettore gruppo09 EEPROM
			RETLW	1E					;carica DIP 2 TX vettore gruppo10 EEPROM
			RETLW	21					;carica DIP 3 TX vettore gruppo11 EEPROM
			RETLW	24					;carica DIP 4 TX vettore gruppo12 EEPROM
			RETLW	27					;carica DIP 5 TX vettore gruppo13 EEPROM
			RETLW	2A					;carica DIP 6 TX vettore gruppo14 EEPROM
			RETLW	2D					;carica DIP 7 TX vettore gruppo15 EEPROM
		
;---- tabella BYTE -------------------------------------------------------------------------

TABLE_BYTE	ADDWF 	PCL,1				;addiziona W,cio PUNTA, a PCL per puntare
			NOP							;non esegue nulla
			MOVF	BYTE_1,0			;carica BYTE_1 - formato PLL in W
			RETURN						;ritorna alla chiamata
			MOVF	BYTE_2,0			;carica BYTE_2 - formato PLL in W
			RETURN						;ritorna alla chiamata
			MOVF	BYTE_3,0			;carica BYTE_3 - formato PLL in W
			RETURN						;ritorna alla chiamata
			MOVF	BYTE_4,0			;carica BYTE_4 - formato PLL in W
			RETURN						;ritorna alla chiamata
			MOVF	BYTE_5,0			;carica BYTE_5 - formato PLL in W
			RETURN						;ritorna alla chiamata
		
;___________________________________________________________________________________________

;===========================================================================================
;  ROUTINE VARIE 
;===========================================================================================		

;=== ROUTINE DI VERIFICA SE SI SONO GIA'RAGGIUNTI I FONDO SCALA ============================

;---- Verifica UP --------------------------------------------------------------------------

VERIF_UP	BTFSC	FLAG_OV,1			;testa il bit1 di FLAG_OV
			GOTO	CONF_LED			; a 1:fondo scala gi raggiunto,ignora UP
			GOTO	UP					; a 0: va a incrementare il PLL

;---- Verifica DOWN ------------------------------------------------------------------------

VERIF_DOWN	BTFSC	FLAG_OV,0			;testa il bit0 di FLAG_OV
			GOTO	CONF_LED			; a 1:inizio scala gi raggiunto,ignora DOWN
			GOTO	DOWN				; a 0: va a decrementare il PLL

;---- Riaccende LED conferme di fondo scala se spento dal movimento di DIP -----------------

CONF_LED	BSF		PORTA,1				;attiva il LED conferme 
			GOTO	VER_AGG				;va al programma principale

;=== ROUTINE FREQUENZA UP ==================================================================

;---- UP con protezione fondo scala,si blocca al raggiungimento ----------------------------

UP			BCF		FLAG_OV,0			;azzera eventuale Flag di inizio scala DOWN in bit0
			CALL	LED					;attiva il LED conferme
			BTFSS	SW,0				;testa SW per selezionare UP_63 oppure UP_127 
			GOTO	UP_127				;se a 0 va a UP_127
			GOTO	UP_63				;se a 1 va a UP_63
INCR_N		MOVLW	00					;carica 0 in W
			MOVWF	A					;azzera A
			BCF		STATUS,C			;azzera il bit di Carry
			MOVLW 	01					;mette 01 in W
			ADDWF	N_LSB,1				;incrementa la parte bassa di N
			BTFSS	STATUS,C			;testa Carry:se a 1 c' stato riporto
			GOTO	ROUT_PLL			;C=0: non c' stato rip.,va a caricare nuovo val.PLL
			INCF	N_MSB,1				;C=1: incrementa la parte alta di N
			BTFSS	N_MSB,3				;testa bit3 N_MSB:se a 1 si  raggiunto fondo scala
			GOTO	ROUT_PLL			;niente fondo scala,va a caricare nuovo valore PLL

;---- si  raggiunto il fondo scala: si carica N=2047 e poi A dipendentemente da SW --------

			MOVLW	07					;mette in W b'00000111'
			MOVWF	N_MSB				;carica in N_MSB il valore di fondo scala
			MOVLW	0FF					;mette in W b'11111111'
			MOVWF	N_LSB				;carica in N_LSB il valore di fondo scala
			BTFSS	SW,0				;testa W 
			GOTO	A_127				;se a 0 va a A_127
			GOTO	A_63				;se a 1 va a A_63

;---- N=2047, si carica A=63 perch SW=1 cio prescaler a 64 -------------------------------

A_63		MOVLW	3F					;mette in W b'00111111'ovvero 63d
			MOVWF	A					;carica in A il valore di fondo scala con presc.64
			BSF		FLAG_OV,1			;setta il bit1 di FLAG_OV per raggiunto fondo scala
			BSF		PORTA,1				;accende fisso il LED conferme			
			GOTO	ROUT_PLL			;tutto fondo scala,va a caricare nuovo valore PLL

;---- N=2047, si carica A=127 perch SW=0 cio prescaler a 128 -----------------------------

A_127		MOVLW	7F					;mette in W b'01111111'ovvero 127d
			MOVWF	A					;carica in A il valore di fondo scala con presc.128
			BSF		FLAG_OV,1			;setta il bit1 di FLAG_OV per raggiunto fondo scala
			BSF		PORTA,1				;accende fisso il LED conferme			
			GOTO	ROUT_PLL			;tutto fondo scala,va a caricare nuovo valore PLL

;----- incrementa A con UP_63 per SW=1 cio P=64 e verifica eventuale incremento di N ------		

UP_63		INCF	A,1					;incrementa A di una unit
			BTFSS	A,6					;testa bit6 A:se a 1 c' stato un riporto 
			GOTO	ROUT_PLL			;non c' stato riporto,va a caricare nuovo valore PLL
			GOTO	INCR_N				;c' stato riporto,va a incrementare N

;----- incrementa A con UP_127 per SW=0 cio P=128 e verifica eventuale incremento di N ----

UP_127		INCF	A,1					;incrementa A di una unit
			BTFSS	A,7					;testa bit7 A:se a 1 c' stato un riporto 
			GOTO	ROUT_PLL			;non c' stato riporto,va a caricare nuovo valore PLL
			GOTO	INCR_N				;c' stato riporto,va a incrementare N

;=== ROUTINE FREQUENZA DOWN ================================================================

;---- DOWN con protezione di inizio scala, si blocca al raggiungimento ---------------------

DOWN		BCF		FLAG_OV,1			;azzera eventuale Flag di fondo scala UP in bit1
			CALL 	LED					;attiva il LED conferme
			BTFSS	SW,0				;testa SW per selezionare DOWN_63 oppure DOWN_127 
			GOTO	DOWN_127			;se a 0 va a DOWN_127 cio con prescaler 128
			GOTO	DOWN_63				;se a 1 va a DOWN_63 cio con prescaler 64

;---- decrementa N e controlla se la parte pi significativa di N  gi a zero -------------

DECR_N		DECF	N_LSB,1				;decrementa la parte meno significativa di N	
			BCF		STATUS,Z			;azzera bit di zero
			MOVF	N_MSB,0				;mette N_MSB in W
			SUBLW	00					;la sottrae a 00
			BTFSS	STATUS,Z			;testa Z,se 1 salta (ha dato zero)
			GOTO	DECR				;Z=0 esce dal test(N_MSB>0),va a DECR
			BTFSS	SW,0				;Z=1 (N_MSB=0),testa W 
			GOTO	N_128				;se a 0 va a N_128
			GOTO	N_64				;se a 1 va a N_64

;---- verifica se N>A con SW=1 cio prescaler 64 per eventuale raggiungimento inizio scala -
;---- se raggiunto carica il minimo valore in PLL: N=64 e A=0 ------------------------------

N_64		MOVF	N_LSB,0				;mette N_LSB in W
			SUBLW	3F					;la sottrae a 3F ovvero dec 63
			BTFSS	STATUS,Z			;testa Z,se 1 salta (ha dato zero)
			GOTO 	DECR				;Z=1 esce dal test,va a DECR
			MOVLW	40					;Z=0 inizio scala raggiunto,mette 40 in W
			MOVWF   N_LSB				;carica il minimo valore di N con SW=1 cio pres.64
			MOVLW	00					;mette 00 in W
			MOVWF	A					;carica 00 in A
			BSF		FLAG_OV,0			;setta il bit0 di FLAG_OV per raggiunto iniz. scala
			BSF		PORTA,1				;accende fisso il LED conferme
			GOTO	ROUT_PLL			;va a caricare il minimo valore in PLL

;---- verifica se N>A con SW=0 cio prescaler 127 per eventuale raggiungimento inizio scala- 
;---- se raggiunto carica il minimo valore in PLL: N=128 e A=0 -----------------------------


N_128		MOVF	N_LSB,0				;mette N_LSB in W
			SUBLW	7F					;la sottrae a 7F ovvero dec 127
			BTFSS	STATUS,Z			;testa Z,se 1 salta (ha dato zero)
			GOTO 	DECR				;Z=1 esce dal test,va a DECR
			MOVLW	80					;Z=0 inizio scala raggiunto,mette 80 in W
			MOVWF   N_LSB				;carica il minimo valore di N con SW=0 cio pres.128
			MOVLW	00					;mette 00 in W
			MOVWF	A					;carica 00 in A
			BSF		FLAG_OV,0			;setta il bit0 di FLAG_OV per raggiunto iniz. scala
			BSF		PORTA,1				;accende fisso il LED conferme
			GOTO	ROUT_PLL			;va a caricare il minimo valore in PLL

;---- N>A, niente fondo scala, decrementa N ------------------------------------------------

DECR		MOVF	N_LSB,0				;mette N_LSB in W
			SUBLW	0FF					;la sottrae a FF
			BTFSS	STATUS,Z			;testa Z,se 1 salta (ha dato zero)
			GOTO	ROUT_PLL			;Z=0 carica nuovo valore PLL
			DECF	N_MSB,1				;Z=1 decrementa la parte pi sign.di N 
			GOTO	ROUT_PLL			;va a caricare nuovo valore PLL

;----- decrementa A con DOWN_63 per SW=1 cio P=64 e verifica eventuale decremento di N ----

DOWN_63		DECF	A,1					;decrementa A e lo mette in A
			BTFSS	A,6					;testa bit6 A:se a 1 si  sorpassato lo zero 
			GOTO	ROUT_PLL			;non si  sorpassato lo zero,carica nuovo valore PLL
			MOVLW	3F					;si  sorpassato lo zero mette b'00111111' in W
			MOVWF	A					;carica A=63
			GOTO	DECR_N				;va a decrementare N

;----- decrementa A con DOWN_127 per SW=0 cio P=128 e verifica eventuale decremento di N --

DOWN_127	DECF	A,1					;decrementa A e lo mette in A
			BTFSS	A,7					;testa bit7 A:se a 1 si  sorpassato lo zero 
			GOTO	ROUT_PLL			;non si  sorpassato lo zero,carica nuovo valore PLL
			MOVLW	7F					;si  sorpassato lo zero mette b'01111111' in W
			MOVWF	A					;carica A=127
			GOTO	DECR_N				;va a decrementare N

;=== ROUTINE LED CONFERME ==================================================================
			
LED			BSF		PORTA,1				;attiva il LED conferme
			MOVLW	0FF					;mette FF in W
			MOVWF 	COUNT1				;lo carica in COUNT1
			MOVLW	040					;mette 40 in W
			MOVWF	COUNT2				;lo carica in COUNT2
DELAY1		DECFSZ	COUNT1,1			;decrementa COUNT1, lo mette in COUNT1,se zero salta
			GOTO	DELAY1				;non zero, ripete il ciclo andando a DELAY1
			CALL	AGGANCIO			; zero, chiama routine di aggancio PLL
			MOVLW	0FF					;mette FF in W
			MOVWF	COUNT1				;lo carica in COUNT1 per riprendere event.il ciclo
			DECFSZ	COUNT2,1			;decrementa COUNT2, lo mette in COUNT2,se zero salta
			GOTO	DELAY1				;non zero, ripete il ciclo andando a DELAY1
			MOVLW	0FF					; zero, mette FF in W
			MOVWF 	COUNT1				;ricarica COUNT1
			MOVLW	040					;mette 40 in W
			MOVWF	COUNT2				;ricarica COUNT2
			BCF		PORTA,1				;disattiva il LED conferme
DELAY2		DECFSZ	COUNT1,1			;decrementa COUNT1, lo mette in COUNT1,se zero salta
			GOTO	DELAY2				;non zero, ripete il ciclo andando a DELAY2
			CALL	AGGANCIO			; zero, chiama routine di aggancio PLL
			MOVLW	0FF					;mette FF in W
			MOVWF	COUNT1				;lo carica in COUNT1 per riprendere event.il ciclo
			DECFSZ	COUNT2,1			;decrementa COUNT2, lo mette in COUNT2,se zero salta
			GOTO	DELAY2				;non zero, ripete il ciclo andando a DELAY2
			MOVLW	0FF					; zero, mette FF in W
			MOVWF 	COUNT1				;ricarica COUNT1
			MOVLW	040					;mette 40 in W
			MOVWF	COUNT2				;ricarica COUNT2	
			RETURN						;ritorna alla chiamata

;=== ROUTINE LED AGGANCIO PLL ==============================================================

;---- COUNT4 definisce la ripetizione del loop campionamento COUNT3 per LED aggancio -------
;---- COUNT3 esegue il campionamento 255 volte per le 8 volte di COUNT4 che ritorna alla 
;---- routine principale di volta in volta.Alla fine decide se PLL agganciato o no ---------
	
AGGANCIO	MOVLW	0FF					;mette FF in W
			MOVWF	COUNT3				;carica loop campionamenti			
LOOP_AGG	DECFSZ  COUNT3,1			;decrementa COUNT3, se zero salta 
			GOTO	TEST_AGG			; uno, va a TEST_AGG
			GOTO	RIP_AGG				; zero, va a RIP_AGG
TEST_AGG	BTFSC	PORTB,0				;testa segnale aggancio dal PLL, se zero salta
			GOTO	LOOP_AGG			;PB0  uno: PLL agganciato, va a loop aggancio
			MOVLW	00					;PB0  zero: PLL sganciato, mette 00 in W
			MOVWF	FLAG_AGG			;setta FLAG_AGG per indicare PLL sganciato
			GOTO	LOOP_AGG			;va a  LOOP_AGG per continuare il campionamento
RIP_AGG		DECFSZ  COUNT4,1			;decrem. ripetizione loop campionamenti,se 0 salta
			RETURN						; uno, ritorna alla chiamata
			BTFSC	FLAG_AGG,0			; zero, verifica il flag aggancio,se zero salta
			GOTO	AGGANCIATO			; uno,va ad agganciato
			BTFSC	BIT_LIV,0			; zero,testa BIT_LIV per liv.LED agganc.,se 0 salta 
			GOTO	INV_NO_AGG			; uno, va a INV_NO_AGG per invers.liv.LED sganciato
			BCF		PORTA,0				; zero,PLL sganciato,LED OFF (normale)
			GOTO	PAR_AGG				;va a ricaricare parametri aggancio
INV_NO_AGG	BSF		PORTA,0				;PLL sganciato,LED ON (invertito)
			GOTO	PAR_AGG				;va a ricaricare parametri aggancio
AGGANCIATO	BTFSC	BIT_LIV,0			;testa BIT_LIV per livello LED aggancio,se 0 salta 
			GOTO	INV_AGG				; uno, va a INV_AGG per invers.liv.LED agganciato
			BSF		PORTA,0				; zero,PLL agganciato,LED ON (normale)
			GOTO	PAR_AGG				;va a ricaricare parametri aggancio
INV_AGG		BCF		PORTA,0				;PLL agganciato,LED OFF (invertito)
PAR_AGG		MOVLW	01					;mette 01 in W
			MOVWF	FLAG_AGG			;setta a 1 FLAG_AGG
			MOVLW	08					;mette 08 in W
			MOVWF	COUNT4				;ricarica COUNT4 ripetizione loop campionamenti
			RETURN						;ritorna alla chiamata

;===========================================================================================
	
			END
	
;===========================================================================================
		


	


